
/*
 * $Id$
 *
 * (C) by abook developers
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_CONFIG_H
#	include "../config.h"
#endif
#include "../abook.h"
#include "../db_access.h"
#include "../misc.h"
#include "../xmalloc.h"

#include "filter_interface.h"
#include "filter.h"

#include "csv_common.h"


static int csv_conv_table[] = {
	NAME,
	EMAIL,
	PHONE,
	NOTES,
	NICK
};

static int
csv_parse_file(FILE *in)
{
	init_csv_common(&ops);

	return csv_parse_file_common(in, csv_conv_table,
		CSV_TABLE_SIZE(csv_conv_table));
}

static int
csv_export_database(FILE *out, struct db_enumerator e)
{
	int csv_export_fields[] = {
		NAME,
		EMAIL,
		PHONE,
		NOTES,
		NICK,
		CSV_LAST
	};

	init_csv_common(&ops);

	csv_export_common(out, e, csv_export_fields, NULL);

	return 0;
}



/*
 * Using filter helper
 */
#define FILTER_NAME csv
#define FILTER_DESCRIPTION N_("comma separated values")
#define FILTER_IMPORT_FUNCTION csv_parse_file
#define FILTER_EXPORT_FUNCTION csv_export_database
#include "filter_helper.h"
