#ifndef _FILTERS_FILTER_HELPER_H
#define _FILTERS_FILTER_HELPER_H

/*
 * Helper for filter module writing.
 *
 * To be included at the end of the filter source file, after having filled
 * the FILTER_* macros to sensible values.
 *
 * Also see filters/filter.h
 */

#ifndef FILTER_NAME
# error No FILTER_NAME macro defined
#endif

#define filter_init XINIT_LTX(FILTER_NAME)

#ifndef FILTER_IMPORT_FUNCTION
# define FILTER_IMPORT_FUNCTION NULL
#endif

#ifndef FILTER_EXPORT_FUNCTION
# define FILTER_EXPORT_FUNCTION NULL
#endif

static struct filter_ops my_ops;

static char *
filter_description()
{
	return FILTER_DESCRIPTION;
}

struct filter_ops *
filter_init(struct abook_ops *main_ops)
{
	if(main_ops)
		memcpy(&OPS_STRUCT, main_ops, sizeof(struct abook_ops));

	my_ops.export = FILTER_EXPORT_FUNCTION;
	my_ops.import = FILTER_IMPORT_FUNCTION;
	my_ops.description = filter_description;

	return &my_ops;
}

#endif /* _FILTERS_FILTER_HELPER_H */
