
/*
 * $Id$
 *
 * (C) by abook developers
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_CONFIG_H
#	include "../config.h"
#endif
#include "../abook.h"
#include "../db_access.h"
#include "../misc.h"
#include "../xmalloc.h"

#include "filter_interface.h"
#include "filter.h"


static int
wl_export_database(FILE *out, struct db_enumerator e)
{
	abook_list *emails;

	fprintf(out, "# Wanderlust address book written by %s\n\n", PACKAGE);

	db_enumerate_items(e) {
		emails = csv_to_abook_list(db_fget(e.item, EMAIL));
		if(emails != NULL) {
			fprintf(out,
				"%s\t\"%s\"\t\"%s\"\n",
				emails->data,
				safe_str(db_fget(e.item, NICK)),
				safe_str(db_fget(e.item, NAME))
			);
		}
		abook_list_free(&emails);
	}

	fprintf(out, "\n# End of address book file.\n");

	return 0;
}

/*
 * Using filter helper
 */
#define FILTER_NAME wl
#define FILTER_DESCRIPTION N_("Wanderlust address book")
#define FILTER_EXPORT_FUNCTION wl_export_database
#include "filter_helper.h"
